--- openssl-0.9.8a-org/util/pl/OS2-EMX.pl	2003-11-28 23:51:28.000000000 +0900
+++ openssl-0.9.8a/util/pl/OS2-EMX.pl	2005-11-11 05:00:52.000000000 +0900
@@ -3,8 +3,11 @@
 # OS2-EMX.pl - for EMX GCC on OS/2
 #
 
+$ssl=	"open_ssl";
+$crypto="cryptssl";
+
 $o='/';
-$cp='cp';
+$cp='cp -p';
 $rm='rm -f';
 
 $preamble = "SHELL=sh\n";
@@ -25,7 +28,7 @@
 
 # EXE linking stuff
 $link='${CC}';
-$lflags='${CFLAGS} -Zbsd-signals -s';
+$lflags='${CFLAGS} -Zbsd-signals -s -Zstack 0x2000';
 $efile='-o ';
 $exep='.exe';
 $ex_libs="-lsocket";
@@ -68,6 +71,7 @@
 	$sha1_asm_src="crypto/sha/asm/s1-os2.asm";
 	$rmd160_asm_obj="crypto/ripemd/asm/rm-os2$obj";
 	$rmd160_asm_src="crypto/ripemd/asm/rm-os2.asm";
+	$cflags.="-DOPENSSL_BN_ASM_PART_WORDS ";
 	}
 
 if ($shlib)
@@ -87,18 +91,21 @@
 	$target="$target";
 	($Name=$name) =~ tr/a-z/A-Z/;
 
-	$ret.="$target: \$(${Name}OBJ)\n";
+#	$ret.="$target: \$(${Name}OBJ)\n";
+	$ret.="$target: $obj\n";
 	if (!$shlib) 
 		{
 		$ret.="\t\$(RM) $target\n";
-		$ret.="\t\$(MKLIB) $target \$(${Name}OBJ)\n";
+#		$ret.="\t\$(MKLIB) $target \$(${Name}OBJ)\n";
+		$ret.="\t\$(MKLIB) $target $obj\n";
 		$ret.="\t\$(RANLIB) $target\n\n";
 		}
 	else
 		{
 		local($ex)=($target =~ /O_SSL/)?' $(L_CRYPTO)':'';
 		$ex.=' -lsocket';
-		$ret.="\t\$(LINK) \$(SHLIB_CFLAGS) \$(MLFLAGS) $efile$target \$(SHLIB_EX_OBJ) \$(${Name}OBJ) $ex os2/${Name}.def\n";
+#		$ret.="\t\$(LINK) \$(SHLIB_CFLAGS) \$(MLFLAGS) $efile$target \$(SHLIB_EX_OBJ) \$(${Name}OBJ) $ex os2/${Name}.def\n";
+		$ret.="\t\$(LINK) \$(SHLIB_CFLAGS) \$(MLFLAGS) $efile$target \$(SHLIB_EX_OBJ) $obj $ex os2/${Name}.def\n";
 		$ret.="\temximp -o $out_def/$name.a os2/${Name}.def\n";
 		$ret.="\temximp -o $out_def/$name.lib os2/${Name}.def\n\n";
 		}
--- openssl-0.9.8a-org/os2/OS2-EMX.cmd	2003-11-28 23:51:30.000000000 +0900
+++ openssl-0.9.8a/os2/OS2-EMX.cmd	2005-11-11 22:26:20.000000000 +0900
@@ -8,8 +8,10 @@
 perl util\mk1mf.pl dll OS2-EMX > OS2-EMX-DLL.mak
 
 echo Generating export definition files
-perl util\mkdef.pl crypto OS2 > os2\crypto.def
-perl util\mkdef.pl ssl OS2 > os2\ssl.def
+rem perl util\mkdef.pl crypto OS2 > os2\cryptssl.def
+rem perl util\mkdef.pl ssl OS2 > os2\open_ssl.def
+perl util\mkdef.pl crypto OS2 | perl os2\defchunk.pl > os2\cryptssl.def
+perl util\mkdef.pl ssl OS2 | perl os2\defchunk.pl > os2\open_ssl.def
 
 echo Generating x86 for GNU assember
 
@@ -71,10 +73,10 @@
 mkdir noname
 :nomkdir
 
-perl backwardify.pl		crypto.def	>backward_crypto.def
-perl backwardify.pl		ssl.def		>backward_ssl.def
-perl backwardify.pl -noname	crypto.def	>noname\backward_crypto.def
-perl backwardify.pl -noname	ssl.def		>noname\backward_ssl.def
+perl backwardify.pl		cryptssl.def		>backward_crypto.def
+perl backwardify.pl		open_ssl.def		>backward_ssl.def
+perl backwardify.pl -noname	cryptssl.def	>noname\backward_crypto.def
+perl backwardify.pl -noname	open_ssl.def	>noname\backward_ssl.def
 
 echo Creating backward compatibility forwarder dlls:
 echo  crypto.dll
@@ -99,4 +101,4 @@
 echo  make -f OS2-EMX.mak
 echo For dynamic build:
 echo  make -f OS2-EMX-DLL.mak
-echo then rename crypto.dll to cryptssl.dll, ssl.dll to open_ssl.dll
+rem echo then rename crypto.dll to cryptssl.dll, ssl.dll to open_ssl.dll
--- openssl-0.9.8a-org/os2/defchunk.pl	1970-01-01 00:00:00.000000000 
+++ openssl-0.9.8a/os2/defchunk.pl	2005-11-11 22:22:34.000000000 +0900
@@ -0,0 +1,6 @@
+#!/usr/bin/perl -w
+
+while(<>) {
+  s/^(\s*pqueue_print\s*[=\s])/;$1/;
+  print $_;
+}
